#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXK = -1;
const int MAXN = -1;

vector<string> parse(string s) {
	string cur = "";
	bool f = 1;
	vector<string> res;
	for (int i = 0; i < (int)s.length(); i++) {
		if (s[i] == ' ' && f) {
			if (cur != "") res.push_back(cur);
			cur = "";
		}
		else {
			if (s[i] == '"') f ^= 1;
			cur += s[i];
		}
	}
	if (cur != "") res.push_back(cur);
	return res;
}

int main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int sz = 0;
	int n;
	bool first = 1;
	while (cin >> n) {
		if (first) first = 0;
		else cout << endl;
		string s;
		getline(cin, s);
		vector<string> a;
		for (int i = 0; i < n; i++) {
			getline(cin, s);
			a.push_back(parse(s)[0]);
		}
		int m;
		cin >> m;
		getline(cin, s);
		vector<vector<string> > b;
		for (int i = 0; i < m; i++) {
			getline(cin, s);
			b.push_back(parse(s));
		}

		map<string, string> mp;
		for (int i = 0; i < n; i++) mp[a[i]] = a[i];

		for (int i = 0; i < m; i++) {
			if (b[i][0] == "cpy") {
				assert(mp.count(b[i][1]));
				assert(!mp.count(b[i][2]));
				mp[b[i][2]] = mp[b[i][1]];
			}
			if (b[i][0] == "mov") {
				assert(mp.count(b[i][1]));
				assert(!mp.count(b[i][2]));
				mp[b[i][2]] = mp[b[i][1]];
				mp.erase(b[i][1]);
			}
			if (b[i][0] == "new") {
				assert(!mp.count(b[i][1]));
				string g = "nw" + to_string(sz++);
				mp[b[i][1]] = g;
			}
			if (b[i][0] == "del") {
				assert(mp.count(b[i][1]));
				mp.erase(b[i][1]);
			}
		}

		vector<string> ans;

		map<string, string> nmp;
		map<string, string> frst;
		map<string, int> cnt, ncnt;

		for (int i = 0; i < n; i++) cnt[a[i]] = 0;
		for (auto it : mp) {
			cnt[it.second]++;
		}

		for (auto it : cnt) {
			if (it.second == 0) {
				ans.push_back("del " + it.first);
			}
			else ncnt.insert(it);
		}
		cnt = ncnt;

		vector<string> ans2;
		for (auto it : mp) {
			if (it.second.substr(0, 2) == "nw") {
				if (frst.count(it.second)) {
					//cout << "cpy " << frst[it.second] << " " << it.first << endl;
					ans2.push_back("cpy " + frst[it.second] + " " + it.first);
				}
				else {
					frst[it.second] = it.first;
					//cout << "new " << it.first << endl;
					ans2.push_back("new " + it.first);
				}
			}
			else nmp.insert(it);
		}
		mp = nmp;
	

		vector<string> ans3;
		nmp.clear();
		for (auto it : mp) {
			if (mp.count(it.second) && mp[it.second] == it.second && it.first != it.second) {
				//cout << "cpy " << it.second << " " << it.first << endl;
				ans3.push_back("cpy " + it.second + " " + it.first);
			}
			else {
				if (it.first != it.second) nmp.insert(it);
			}
		}
		mp = nmp;

		map<string, string> cur;

		set<pair<int, string> > st;
		cnt.clear();
		for (auto it : mp) {
			cnt[it.second]++;
			cnt[it.first];
		}
		for (auto it : cnt) st.insert(make_pair(it.second, it.first));

		while (1) {
			if (st.empty() || st.begin()->first != 0) break;
			string s = st.begin()->second;
			st.erase(st.begin());
			if (!mp.count(s)) continue;
			if (cur.count(mp[s])) {
				ans.push_back("cpy " + cur[mp[s]] + " " + s);
			}
			else {
				cur[mp[s]] = s;
				ans.push_back("mov " + mp[s] + " " + s);
			}
			st.erase(make_pair(cnt[mp[s]], mp[s]));
			cnt[mp[s]]--;
			st.insert(make_pair(cnt[mp[s]], mp[s]));
			mp.erase(s);
		}

		map<string, int> cnt1, cnt2;
		for (auto it : mp) {
			cnt1[it.second]++;
			cnt2[it.first]++;
		}
		assert(cnt1 == cnt2);

		while (!mp.empty()) {
			string s = mp.begin()->first;
			vector<string> vct;
			string ss = s;
			do {
				vct.push_back(ss);
				ss = mp[ss];
			} while (ss != s);

			int id = -1;
			for (int i = 0; i < (int)vct.size(); i++) {
				if (cur.count(vct[i])) {
					id = i;
					break;
				}
			}
			if (id != -1) {
				for (int i = 0; i < (int)vct.size(); i++) if (!cur.count(vct[i])) cur[vct[i]] = vct[i];

				for (int i = id + 1; i < (int)vct.size(); i++) {
					string o = cur[vct[i]] == vct[i] ? "mov" : "cpy";
					ans.push_back(o + " " + cur[vct[i]] + " " + vct[(i - 1 + (int)vct.size()) % vct.size()]);
				}
				for (int i = 0; i <= id; i++) {
					string o = cur[vct[i]] == vct[i] ? "mov" : "cpy";
					ans.push_back(o + " " + cur[vct[i]] + " " + vct[(i - 1 + (int)vct.size()) % vct.size()]);
				}
			}
			else {
				ans.push_back("mov " + vct[0] + " \"~\"");
				for (int i = 1; i < (int)vct.size(); i++) {
					ans.push_back("mov " + vct[i] + " " + vct[i - 1]);
				}
				ans.push_back("mov \"~\" " + vct.back());
			}
			for (auto x : vct) mp.erase(x);
		}
		for (string s : ans2) ans.push_back(s);
		for (string s : ans3) ans.push_back(s);

		//cerr << mp.size() << endl;
		cout << ans.size() << endl;
		for (string o : ans) cout << o << endl;
	}
	
	return 0;
}
